#!/usr/bin/perl

use Fcntl qw/:flock/;

my $specific = shift;

my $lock_specific = $specific;
$lock_specific =~ s/[^a-zA-Z0-9]/_/g;

my $filename = "/tmp/.reload_asterisk_flag_$lock_specific";
$filename =~ s/ /_/g;

open(LOG, ">>/tmp/xpl.log");
print LOG localtime() . ": $0: $$: creating $filename\n";
close(LOG);

open my $flag, "> $filename" or die $!;

# Non-blocking flock.
unless( flock( $flag, LOCK_NB | LOCK_EX ) )
{
	exit(0);
}
if ( -e '/etc/asterisk/unbound' )
{
	sleep(60);
} else {
	sleep(20);
}

my $reload;
if ($specific =~ /\.so$/)
{
	$reload = "reload $specific";
}
# handle partial reload
elsif($specific =~ /.conf$/)
{
	$reload = "dialplan reload $specific";
}
elsif ($specific)
{
	# don't allow "extensions reload", can cause crashing on asterisk 1.2 if two happen at the same time
	if ($specific eq "extensions")
	{
		$reload = "reload";
	}
	else
	{
		$reload = "module reload $specific";
	}
}
else
{
	$reload = "reload";
}

open(LOG, ">>/tmp/xpl.log");
print LOG localtime() . ": $0: $$: /usr/sbin/asterisk -r -x '$reload'\n";
close(LOG);

system( "/usr/sbin/asterisk -r -x '$reload'" );

# Free the flock
close($flag);

